@echo off
REM **************************************************************************
REM
REM   TiVo Desktop Mp3.dll Source Code and Build Process
REM   Copyright (c) 2003 TiVo Inc.
REM
REM   This library is free software; you can redistribute it and/or modify it
REM   under the terms of the GNU Lesser General Public License as published by
REM   the Free Software Foundation; either version 2.1 of the License, or (at
REM   your option) any later version.
REM
REM   This library is distributed in the hope that it will be useful, but
REM   WITHOUT ANY WARRANTY; without even the implied warranty of
REM   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
REM   General Public License for more details.
REM
REM   You should have received a copy of the GNU Lesser General Public License
REM   along with this library; if not, write to the Free Software Foundation,
REM   Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.
REM
REM   April 4th, 2003
REM
REM   www.tivo.com
REM
REM   TiVo Inc.
REM   P.O. Box 2160
REM   Alviso, CA 95002
REM
REM **************************************************************************


REM //////////////////////////////////////////////////////////////////////////////////////////////
REM
REM  Build.bat
REM
REM  Builds all project targets.
REM
REM
REM  Copyright (c) 2002 TiVo Inc., all rights reserved.
REM
REM //////////////////////////////////////////////////////////////////////////////////////////////


REM Make sure our batch syntax will work.

if not %CMDEXTVERSION% geq 2 (echo Sorry, this batch requires Windows 2000 CMD.EXE! & exit /b 1)


REM Make sure our directory structure is in place.

call MkDirs.bat
if ERRORLEVEL 1 goto OnError


echo.
echo ####################################################################
echo #
echo # Build.h
echo #
echo ####################################################################
echo.

set BUILD_H=Src\Common\Build.h
erase /f %BUILD_H% 2> nul

echo // This file was generated by %~f0!        >  %BUILD_H%
echo.                                           >> %BUILD_H%
echo #define P4SYNCVER 0                        >> %BUILD_H%
echo #define P4SYNCVER_STR "0"                  >> %BUILD_H%
echo #define BUILD_DESCRIPTION "This is a private build, for development purposes only.\r\n\r\nCreator: %USERNAME%\r\nMachine: %COMPUTERNAME%\r\nDate: %DATE%\r\nTime: %TIME%" >> %BUILD_H%

type %BUILD_H%

echo.
echo ####################################################################
echo #
echo # Removing old VERSIONINFO images to ensure re-link.
echo #
echo ####################################################################
echo.

erase /f /s Obj\Version.* 2> nul

echo.
echo ####################################################################
echo #
echo # Building...
echo #
echo ####################################################################
echo.

pushd Src
call Build.bat
popd
if ERRORLEVEL 1 goto OnError

goto OnDone

:OnError

echo.
echo ####################################################################
echo #
echo # Build FAILED!
echo #
echo ####################################################################
echo.

exit /b 1

:OnDone

echo.
echo ####################################################################
echo #
echo # Build completed OK.
echo #
echo ####################################################################
echo.

exit /b 0
