@echo off
REM **************************************************************************
REM
REM   TiVo Desktop Mp3.dll Source Code and Build Process
REM   Copyright (c) 2003 TiVo Inc.
REM
REM   This library is free software; you can redistribute it and/or modify it
REM   under the terms of the GNU Lesser General Public License as published by
REM   the Free Software Foundation; either version 2.1 of the License, or (at
REM   your option) any later version.
REM
REM   This library is distributed in the hope that it will be useful, but
REM   WITHOUT ANY WARRANTY; without even the implied warranty of
REM   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
REM   General Public License for more details.
REM
REM   You should have received a copy of the GNU Lesser General Public License
REM   along with this library; if not, write to the Free Software Foundation,
REM   Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.
REM
REM   April 4th, 2003
REM
REM   www.tivo.com
REM
REM   TiVo Inc.
REM   P.O. Box 2160
REM   Alviso, CA 95002
REM
REM **************************************************************************


REM ///////////////////////////////////////////////////////////////////////////
REM
REM  MkDirs.bat
REM
REM  Completes the project directory structure.
REM
REM
REM  Copyright (c) 2002 TiVo Inc., all rights reserved.
REM
REM ///////////////////////////////////////////////////////////////////////////

REM Check that all of our batch syntax will work.

if not %CMDEXTVERSION% geq 2 (echo Sorry, this batch requires Windows 2000 CMD.EXE! & exit /b 1)


REM If we're being recusively called from our own for loop (below), just
REM quit now.

if "%1"=="Nesting" exit /b

REM Make sure all of our sibling projects have had their directories made.

for /d %%X in (..\..\*) do if exist %%X\MkDirs.bat (pushd %%X & call MkDirs.bat Nesting & popd)

REM Finally, make our directories.

mkdir Bin > nul 2>&1
mkdir Obj > nul 2>&1
mkdir Obj\Mp3 > nul 2>&1

REM We know that the above mkdir commands will set ERRORLEVEL if the directory
REM already exists. As this is expected and harmless, we always force a zero
REM exit code.  Of course, this will mask actual mkdir failures.  However,
REM should one ever occur, it will still be highlighted by other failures down
REM the line.

exit /b 0

