/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_04E77277_2EBE_4FA6_9BFB_6380E03C419D
#define INCLUDE_GUARD_04E77277_2EBE_4FA6_9BFB_6380E03C419D

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// AudioApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct StreamApi;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// AudioApi
//
//  Every DLL housing one or more audio conversion modules should support this interface via
//  Media_GetApi().
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct AudioApi: TivoApi::Api
{

    // Requests that the data generated by Audio_GetStreamApi() result in playback that starts
    // at the given offset (in millisecods) within the audio.  Returns FALSE if an error occurs.

    virtual BOOL        TIVO_API_METHOD Audio_Seek(DWORD time) = 0;


    // Requests that the data generated by Audio_GetStreamApi() result in audio that plays for
    // the given length of time (in milliseconds).  Returns FALSE if an error occurs.

    virtual BOOL        TIVO_API_METHOD Audio_SetDuration(DWORD time) = 0;


    // Renders binary data for the audio in the given format, specified as a MIME type, which
    // should always match one of the entries in the list returned by the associated module's
    // Media_GetTargetFormats() method.  Returns NULL if the requested format is not supported
    // or an error occurs.  The former case can be distinguised from the latter by checking
    // GetLastError() for ERROR_UNSUPPORTED_TYPE.
    //
    // For example, "image/mpeg" will be specified when MPEG data is desired.

    virtual StreamApi*  TIVO_API_METHOD Audio_GetStreamApi(LPCSTR format) = 0;

};


#endif // INCLUDE_GUARD