/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_10D8D7F4_8FB1_4607_A27A_FB009AAE20F4
#define INCLUDE_GUARD_10D8D7F4_8FB1_4607_A27A_FB009AAE20F4

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// CacheApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DataApi;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// CacheApi
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct CacheApi: TivoApi::Api
{

    // This method updates (or adds) the indicated data to the cache. If expiration is
    // specified, it represents the time past which this cached data will not be returned.
    // If 'expiration' is NULL, then this data will not expire.  The string supplied as
    // 'tag' should be unique for each item of data placed in the cache.  Returns FALSE if
    // an error occurs.

    virtual BOOL        TIVO_API_METHOD Cache_UpdateData
                                        (
                                            LPCSTR          tag,
                                            DataApi*        data,
                                            const FILETIME* expiration

                                        ) = 0;


    // Removes the indicated data from the cache, if present.

    virtual void        TIVO_API_METHOD Cache_PurgeData(LPCSTR tag) = 0;


    // Retrieves the indicated data from the cache.  The 'source' time will allow the cache
    // to determine if the cached version is out-of-date.  If 'source' is NULL, then the
    // out-of-date check is skipped, and the data is returned if it exists in the cache.
    // Returns NULL if the data has been purged (or was never added), is out of date, or if
    // an error occurs.  The former cases can be distinguished from the latter by checking
    // GetLastError() for ERROR_NOT_FOUND.

    virtual DataApi*    TIVO_API_METHOD Cache_GetDataApi
                                        (
                                            LPCSTR          tag,
                                            const FILETIME* source

                                        ) = 0;

};


#endif // INCLUDE_GUARD
