/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_A90600BA_74C6_4A35_B3F7_3277B6085666
#define INCLUDE_GUARD_A90600BA_74C6_4A35_B3F7_3277B6085666

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// ComHelpApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DataApi;
struct IStream;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// ComHelpApi
//
//  This interface is retrieved via Host_GetApi().
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct ComHelpApi: TivoApi::Api
{

    // Returns a COM interface which can be used for writing arbitrary data, or NULL if an
    // error occurs.  A "hint" can be given to indicate to the host program the approximate
    // size of the data to be written.
    //
    // Com_DataApiFromIStream() can be used if a DataApi for the written data is then needed.

    virtual IStream*    TIVO_API_METHOD Com_CreateIStream(DWORD hint = 0) = 0;


    // Returns a COM interface which can be used only for reading the given data, or NULL if
    // an error occurs.

    virtual IStream*    TIVO_API_METHOD Com_IStreamFromDataApi(DataApi* data) = 0;


    // Returns an interface which can be used only for reading data from the given stream, or
    // NULL if an error occurs.

    virtual DataApi*    TIVO_API_METHOD Com_DataApiFromIStream(IStream* stream) = 0;

};


#endif // INCLUDE_GUARD
