/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_0A9D1C1F_F049_4D2D_A98E_9DA0887A7171
#define INCLUDE_GUARD_0A9D1C1F_F049_4D2D_A98E_9DA0887A7171

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// DiskCacheApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "Api/CacheApi.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DiskCacheParams;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// DiskCacheApi
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct DiskCacheApi: CacheApi
{

    // Connects/disconnects the DiskCacheApi instance with the disk folder set by SetParams().
    // While disconnected, the CacheApi portion will accept updates and queries without error,
    // but also without actually doing anything.  Returns FALSE if an error occurs.

    virtual BOOL    TIVO_API_METHOD Cache_Connect() = 0;

    virtual void    TIVO_API_METHOD Cache_Disconnect() = 0;


    // Returns the current settings.  This function can be called at any time.

    virtual void    TIVO_API_METHOD Cache_GetParams(DiskCacheParams* params) = 0;


    // Changes the current settings.  This function can be called at any time.

    virtual BOOL    TIVO_API_METHOD Cache_SetParams(const DiskCacheParams* params) = 0;

};


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DiskCacheParams
{
    CHAR            Folder[MAX_PATH];
    DWORD           MaxSize;
};


#endif // INCLUDE_GUARD
