/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_A6F5FA83_7E2B_4017_B38F_615531324167
#define INCLUDE_GUARD_A6F5FA83_7E2B_4017_B38F_615531324167

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// FileViewApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "Api/DataApi.h"
#include "Api/UrlApi.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct FileViewApi: DataApi
{

    // Specifies the file to be viewed.  This method will always be called before any others.
    // Returns FALSE if an error occurs, after which no other methods other than Api_AddRef()
    // and/or Api_Release() will be called.

    virtual BOOL TIVO_API_METHOD    File_Initialize(UrlApi* url) = 0;


    // Returns the times the underlying file was created, last accessed, and/or last modified.
    // Returns FALSE if an error occurs.  If any of the times are not available, all members
    // of the corresponding FILETIME structure will be set to zero.
    //
    // Note that any parameter(s) may be set to NULL if the information is not desired.

    virtual BOOL TIVO_API_METHOD    File_GetTimes
                                    (
                                        LPFILETIME created,
                                        LPFILETIME accessed,
                                        LPFILETIME modified

                                    ) = 0;

};


#endif // INCLUDE_GUARD
