/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_9F74839F_FD1E_4D4A_A196_D536E95D749B
#define INCLUDE_GUARD_9F74839F_FD1E_4D4A_A196_D536E95D749B

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// HostProgramApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct ModuleApi;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// HostProgramApi
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct HostProgramApi: TivoApi::Api
{

    // Returns the handle of the main window belonging to the host program.  If the program
    // has no user interface, this function may return NULL.

    virtual HWND            TIVO_API_METHOD Host_GetMainWindow() = 0;


    // Returns the name of the computer running the host program.  Returns NULL if an error
    // occurs.

    virtual LPCSTR          TIVO_API_METHOD Host_GetComputerName() = 0;


    // This function can be used to retrieve the following interfaces:
    //
    //  RegistryApi
    //  FileViewApi
    //  CacheApi
    //  MediaApi
    //  FormatApi
    //  ComHelpApi
    //  DetailsHelpApi
    //  UrlApi
    //
    // Returns NULL if the requested interface is not supported, or if an error occurs.  The
    // former case can be distinguished from the latter by checking GetLastError() for
    // ERROR_INVALID_PARAMETER.

    virtual TivoApi::Api*   TIVO_API_METHOD Host_GetApi(LPCSTR type_id, ModuleApi* module) = 0;

};


#endif // INCLUDE_GUARD
