/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_26D78A2A_7E65_4EA0_905A_5299C8C5CF7C
#define INCLUDE_GUARD_26D78A2A_7E65_4EA0_905A_5299C8C5CF7C

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// LinksApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// This interface is retrieved via Media_GetApi().  The list of links available depends on the
// specified URL.
//
// See the "Calpyso Server Protocol Specification" for a list of links.  The types returned by
// DetailsApi should match the XML meta-data element names defined in the specification.
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct LinksApi: TivoApi::Api
{

    // These methods enumerate the available links.  Returns NULL if no (or no more) links are
    // supported or if an error occurs.  The former case can be distinguished from the latter
    // by checking GetLastError() for ERROR_NO_MORE_ITEMS.
    //
    // No type should occur more than once within a particular set of links.

    virtual LPCSTR      TIVO_API_METHOD Links_GetFirstType() = 0;
    virtual LPCSTR      TIVO_API_METHOD Links_GetNextType() = 0;


    // Returns details associated with the given link type.  Returns NULL if the requested link
    // is not available or if an error occcurs.  The former case can be distinguished from the
    // latter by checking GetLastError() for ERROR_NOT_FOUND.
    //
    // The instance of DetailsApi returned will always have at least one key named "Url", whose
    // value is the "basic" URL for the link.  Other keys and values, whose meanings depend on
    // on the specific type of link being queried, can also be returned.

    virtual DetailsApi* TIVO_API_METHOD Links_QueryDetailsApi(LPCSTR type) = 0;

};


#endif // INCLUDE_GUARD
