/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_8936431D_EAFF_456B_AAA8_894B4DF45E62
#define INCLUDE_GUARD_8936431D_EAFF_456B_AAA8_894B4DF45E62

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// StreamApi.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DataApi;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// StreamApi
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct StreamApi: TivoApi::Api
{

    // Returns the total size of all "chunks" of data in the stream.  For "infinite" streams,
    // such as Internet radio broadcasts, returns -1.

    virtual LONG        TIVO_API_METHOD Stream_GetTotalSize() = 0;


    // Returns the successive "chunks" of data in the stream, starting with the first.  The
    // size of each chunk can be determined by calling Data_GetSize().  After Stream_Reset()
    // is called, the first chunk is returned again.  Returns NULL when no more chunks are
    // available or if an error occurs.  The former case can be distinguished from the latter
    // by checking GetLastError() for ERROR_NO_MORE_ITEMS.
    //
    // For "infinite" streams, the "first" chunk is always whatever the current chunk is.

    virtual DataApi*    TIVO_API_METHOD Stream_GetNextDataApi() = 0;


    // Resets the behavior of Stream_GetNextDataApi() as described above.  This method has no
    // effect on "infinite" streams.

    virtual void        TIVO_API_METHOD Stream_Reset() = 0;

};


#endif // INCLUDE_GUARD
