/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_73D1E172_086F_4835_BED4_8366FF21CBFF
#define INCLUDE_GUARD_73D1E172_086F_4835_BED4_8366FF21CBFF

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// ApiRefs.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/ApiRef.h"

#include "Api/HostProgramApi.h"
#include "Api/AudioApi.h"
#include "Api/ComHelpApi.h"
#include "Api/ContainerApi.h"
#include "Api/DataApi.h"
#include "Api/CacheApi.h"
#include "Api/DiskCacheApi.h"
#include "Api/StreamApi.h"
#include "Api/DetailsApi.h"
#include "Api/FileViewApi.h"
#include "Api/ImageApi.h"
#include "Api/LinksApi.h"
#include "Api/MediaApi.h"
#include "Api/MediaClassApi.h"
#include "Api/FormatApi.h"
#include "Api/ModuleApi.h"
#include "Api/RegistryApi.h"
#include "Api/UrlApi.h"
#include "Api/DetailsHelpApi.h"
#include "Api/LogApi.h"

using namespace TivoApi;


//////////////////////////////////////////////////////////////////////////////////////////////////

typedef ApiRef<HostProgramApi> HostProgramRef;
typedef ApiRef<RegistryApi> RegistryRef;
typedef ApiRef<UrlApi> UrlRef;
typedef ApiRef<UrlBuilderApi> UrlBuilderRef;
typedef ApiRef<FormatApi> FormatRef;
typedef ApiRef<ComHelpApi> ComHelpRef;
typedef ApiRef<ModuleApi> ModuleRef;
typedef ApiRef<ModuleGroupApi> ModuleGroupRef;
typedef ApiRef<MediaApi> MediaRef;
typedef ApiRef<MediaClassApi> MediaClassRef;
typedef ApiRef<LinksApi> LinksRef;
typedef ApiRef<DetailsApi> DetailsRef;
typedef ApiRef<FilterDetailsApi> FilterDetailsRef;
typedef ApiRef<ImageApi> ImageRef;
typedef ApiRef<AudioApi> AudioRef;
typedef ApiRef<ContainerApi> ContainerRef;
typedef ApiRef<FilterContainerApi> FilterContainerRef;
typedef ApiRef<ContainerCallbackApi> ContainerCallbackRef;
typedef ApiRef<DataApi> DataRef;
typedef ApiRef<CacheApi> CacheRef;
typedef ApiRef<DiskCacheApi> DiskCacheRef;
typedef ApiRef<StreamApi> StreamRef;
typedef ApiRef<FileViewApi> FileViewRef;
typedef ApiRef<DetailsHelpApi> DetailsHelpRef;
typedef ApiRef<LogApi> LogRef;


//////////////////////////////////////////////////////////////////////////////////////////////////

template <typename T>
inline T* AddRef(T* api)
{
    if (api)
    {
        api->Api_AddRef();
    }

    return api;
}


#endif // INCLUDE_GUARD
