/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// AutoUtils.h
//
//
// Copyright (c) 2003 TiVo Inc., all rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
#ifndef INCLUDE_GUARD_C5C73FB8_F6F3_4D5A_8500_213B36791B3A
#define INCLUDE_GUARD_C5C73FB8_F6F3_4D5A_8500_213B36791B3A

#include <windows.h>

////////////////////////////////////////////////////////////////////////////////
// A simple Auto critical section manager class
class AutoCrit
{
    public:

    typedef CRITICAL_SECTION DataType;

    AutoCrit(DataType &crit) :
        m_crit(&crit)
    {
        EnterCriticalSection(m_crit);
    }

    ~AutoCrit()
    {
        LeaveCriticalSection(m_crit);
    }

    static void Init(DataType &crit)
    {
        InitializeCriticalSection(&crit);
    }

    static void Destroy(DataType &crit)
    {
        DeleteCriticalSection(&crit);
    }

    private:

    DataType *   m_crit;
};
////////////////////////////////////////////////////////////////////////////////
#endif // INCLUDE_GUARD