/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// StringUtils.h
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_GUARD_B809FDB0_DE14_494D_9F70_DA7F5A4901BA
#define INCLUDE_GUARD_B809FDB0_DE14_494D_9F70_DA7F5A4901BA

#include <string>
#include <windows.h>

////////////////////////////////////////////////////////////////////////////////
namespace StringUtils
{

// Safe routine to init a string (no exception when NULL)
std::string SafeString(LPCSTR str, bool check_lasterror = true);

// Get the name + ext from a full path
std::string ExtractFileName(LPCSTR str);
std::string ExtractFileName(const std::string &rstr);

// Get the ext from a full path
std::string ExtractFileExt(LPCSTR str);
std::string ExtractFileExt(const std::string &rstr);

// Get the name from a full path
std::string ExtractFileNameOnly(LPCSTR str);
std::string ExtractFileNameOnly(const std::string &rstr);

// Get the drive and path from a full path
std::string ExtractFilePath(LPCSTR str);
std::string ExtractFilePath(const std::string &rstr);

// Force a string to have (bAdd==true) or not have (bAdd==false) a trailing
// slash.
std::string ForceEndSlash(std::string str, bool bAdd);

// Removes whitespace from the front and the end of the specified string
std::string Trim(LPCSTR in);
__inline std::string Trim(std::string in)
{
    return Trim(in.c_str());
}


} // namespace
////////////////////////////////////////////////////////////////////////////////

#endif // INCLUDE_GUARD