/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Audio.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_GUARD_E247EF56_854E_4FF1_99AE_0158B87B3364
#define INCLUDE_GUARD_E247EF56_854E_4FF1_99AE_0158B87B3364

#include <windows.h>

#include "Api/AudioApi.h"
#include "Api/DataApi.h"
#include "Api/StreamApi.h"

#include "TivoApi/ApiRef.h"
#include "TivoApi/ApiHelp.h"
#include "TivoApi/Dll/DllHelp.h"
#include "Common/ApiRefs.h"
#include "Common/ModuleErrorUtils.h"

#include "AudioModule.h"
#include "MpegAudio.h"

using namespace TivoApi;

////////////////////////////////////////////////////////////////////////////////
class Audio : public RefCounted < Instanced <Audio, Implements<AudioApi> > >
{
    UrlRef                  m_url_api;
    FileViewRef             m_file_view;
    MpegAudio*              m_mpeg_audio;

    LONG                    m_seek_ms;
    LONG                    m_duration_ms;
    LONG                    m_max_length_ms;

    // Helpers

    void PrepareMaxLength();

    public:

    // Ctor & Dtor
    Audio(UrlApi* raw_url);
    ~Audio();

    // AudioApi methods

    BOOL          TIVO_API_METHOD Audio_Seek(DWORD time);

    BOOL          TIVO_API_METHOD Audio_SetDuration(DWORD time);

    StreamApi*    TIVO_API_METHOD Audio_GetStreamApi(LPCSTR format);

};

////////////////////////////////////////////////////////////////////////////////

#endif // INCLUDE_GUARD