/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// AudioModule.h
//
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_GUARD_70D31983_91EA_4B6F_939B_C808D979E774
#define INCLUDE_GUARD_70D31983_91EA_4B6F_939B_C808D979E774

#include <windows.h>

#include "Api/ModuleApi.h"
#include "Api/MediaApi.h"
#include "Api/FormatApi.h"
#include "Api/HostProgramApi.h"

#include "TivoApi/ApiRef.h"
#include "TivoApi/ApiHelp.h"
#include "TivoApi/Dll/DllHelp.h"
#include "Common/ApiRefs.h"
#include "Common/ModuleErrorUtils.h"
#include "Common/StringUtils.h"
#include "Module/Common/BaseModule.h"

using namespace TivoApi;
using namespace StringUtils;

////////////////////////////////////////////////////////////////////////////////
class AudioModule : public BaseModule < AudioModule, RefCounted < Singleton < AudioModule, Implements3 < MediaApi, ModuleApi, FormatApi > > > >
{
    public:

    // Ctor & Dtor
    AudioModule();
    ~AudioModule();

    // ModuleApi methods
    BOOL    TIVO_API_METHOD Module_Initialize(HostProgramApi* host);
    LPCSTR  TIVO_API_METHOD Module_GetDisplayName();
    LPCSTR  TIVO_API_METHOD Module_GetInternalName();

    // MediaApi methods
    LPCSTR  TIVO_API_METHOD Media_GetSourceFormats();
    LPCSTR  TIVO_API_METHOD Media_GetTargetFormats();
    Api*    TIVO_API_METHOD Media_GetApi(LPCSTR type_id, UrlApi* raw_url);

    // FormatApi methods
    DWORD   TIVO_API_METHOD Format_GetNumTypes();
    BOOL    TIVO_API_METHOD Format_GetType(DWORD index, FormatType* type);
    LONG    TIVO_API_METHOD Format_SniffData(UrlApi* raw_url, DataApi* data);
};

typedef AudioModule TheModule;

////////////////////////////////////////////////////////////////////////////////

#endif // INCLUDE_GUARD
