/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#include <Windows.h>

#include "AudioStream.h"

////////////////////////////////////////////////////////////////////////////////
AudioStream::AudioStream
(
    UrlApi* raw_url,
    FileViewApi *fva,
    DWORD begin,
    DWORD length
) :
    m_url_api(raw_url),
    m_file_view(fva),
    m_begin(begin),
    m_length(length),
    m_eos(false)
{
    TheModule::GetSelf()->Api_AddRef();
}
////////////////////////////////////////////////////////////////////////////////
AudioStream::~AudioStream()
{
    TheModule::GetSelf()->Api_Release();
}
////////////////////////////////////////////////////////////////////////////////
LONG     TIVO_API_METHOD AudioStream::Stream_GetTotalSize()
{
    TIVO_API_TRY

    // We only have one block containing the entire image.

    return m_length;

    TIVO_API_CATCH_RETURN(0)
}
////////////////////////////////////////////////////////////////////////////////
DataApi* TIVO_API_METHOD AudioStream::Stream_GetNextDataApi()
{
    TIVO_API_TRY

    if (m_eos)
    {
        SetLastError(ERROR_NO_MORE_ITEMS);
        return NULL;
    }

    // Set our end of stream flag
    m_eos = true;

    // Pass the work on to our AudioData class
    return new AudioData(m_file_view, m_begin, m_length);

    TIVO_API_CATCH_RETURN(NULL)
}
////////////////////////////////////////////////////////////////////////////////
void     TIVO_API_METHOD AudioStream::Stream_Reset()
{
    TIVO_API_TRY

    m_eos = false;

    TIVO_API_CATCH
}
////////////////////////////////////////////////////////////////////////////////
