/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

#ifndef INCLUDE_GUARD_9CCC4865_0EBC_11D5_8018_00A0CCD13742
#define INCLUDE_GUARD_9CCC4865_0EBC_11D5_8018_00A0CCD13742

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// DllApi.h
//
//
// Copyright (c) 2001 TiVo Inc., all rights reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////////////


#include "TivoApi/Api.h"

#include "Windows.h"


namespace TivoApi {


//////////////////////////////////////////////////////////////////////////////////////////////////

struct DllCallbackApi;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Standard entry-point exported by every DLL as "Tivo_GetApi".
//
//////////////////////////////////////////////////////////////////////////////////////////////////

typedef Api* WINAPI (*TivoGetApi)(LPCSTR type_id);


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Exposed by every DLL via Tivo_GetApi("DllApi").
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct DllApi: Api
{
    virtual BOOL TIVO_API_METHOD    Dll_Initialize(DllCallbackApi* callback) = 0;
};


//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Implemented by every DLL client as a requirement of Dll_Initialize().
//
//////////////////////////////////////////////////////////////////////////////////////////////////

struct DllCallbackApi: Api
{
    virtual void TIVO_API_METHOD    Dll_OnApiRelease(Api* old_api) = 0;
};


} // TivoApi


#endif // INCLUDE_GUARD
