/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

///////////////////////////////////////////////////////////////////////////////
//
// id3v1.h
//
// This provides the defines and protos for id3v1 tags
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_GUARD_F997EB9D_25FB_40D4_9CE7_FB2FAC61F395
#define INCLUDE_GUARD_F997EB9D_25FB_40D4_9CE7_FB2FAC61F395

///////////////////////////////////////////////////////////////////////////////

struct id3v1
{
    char           title[31];
    char           artist[31];
    char           album[31];
    char           year[5];
    char           comment[31];
    unsigned char  track;
    unsigned char  genre;
    const char    *genre_string;
};

bool GetId3v1FromMp3File(const char *filename, struct id3v1 *id3);
bool GetId3v1FromMp3Image(long flength, const void *vptr, struct id3v1 *id3);

// General Id3v1 genre index number to string conversion routine
const char *GetId3GenreStringFromIndex(int index);

///////////////////////////////////////////////////////////////////////////////
#endif // INCLUDE_GUARD
