/******************************************************************************

    TiVo Desktop Mp3.dll Source Code and Build Process
    Copyright (c) 2003 TiVo Inc.

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or (at
    your option) any later version.

    This library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
    General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307 USA.

    April 4th, 2003

    www.tivo.com

    TiVo Inc.
    P.O. Box 2160
    Alviso, CA 95002

******************************************************************************/

///////////////////////////////////////////////////////////////////////////////
//
// id3v2.h
//
// This provides the defines and protos for id3v2 tags
//
// Copyright (c) 2002 TiVo Inc., all rights reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_GUARD_5B5048E8_4B20_49F9_97C9_66B4A0D046DB
#define INCLUDE_GUARD_5B5048E8_4B20_49F9_97C9_66B4A0D046DB

///////////////////////////////////////////////////////////////////////////////

#include <string>

///////////////////////////////////////////////////////////////////////////////

struct id3v2
{
    bool        is_id3v2_present;
    // With Id3Lib use the ID3FN_TEXT field for all of these frames:

    std::string title;          // ID3FID_TITLE
    std::string subtitle;       // ID3FID_SUBTITLE
    std::string artist;         // ID3FID_COMPOSER
    std::string album;          // ID3FID_ALBUM
    std::string year;           // ID3FID_YEAR
    std::string comment;        // ID3FID_COMMENT
    std::string track;          // ID3FID_TRACKNUM
    std::string genre;          // ID3FID_CONTENTTYPE
    std::string record_label;   // ID3FID_PUBLISHER
    std::string copyright;      // ID3FID_COPYRIGHT
    std::string date;           // ID3FID_DATE
    std::string time;           // ID3FID_TIME

     id3v2() : is_id3v2_present(false) {}
    ~id3v2()                           {}
};

bool GetId3v2FromMp3File(const char *filename, struct id3v2 *id3);
bool GetId3v2FromMp3Image(long flength, const void *vptr, struct id3v2 *id3);

///////////////////////////////////////////////////////////////////////////////
#endif // INCLUDE_GUARD
